unit threeToTwo;

interface
function c3_to_2(inS: PChar; OutS: PChar) : Longword;
procedure c2_to_3(inS: PChar;  len: Word; outS: PChar);

implementation

uses SysUtils;

function c3_to_2(inS: PChar; outS: PChar) : Longword;
var
i,ii,iii: word;

begin
while ( (StrLen(inS) mod 3) <> 0) do begin
        inS[strlen(inS)] := Chr($20);
        inS[strlen(inS)+1] := Chr($00);
end;

ii := 0;

for i := 0 to strlen(inS) - 1 do begin
        if (ord(inS[i])=$20) then inS[i] := Chr($3C);           		//kodiere Space auf 0x3C
        if (ord(inS[i])=$2f) then inS[i] := Chr($3b);    		//kodiere slash auf 0x3B
        if (ord(inS[i])=$2d) then inS[i] := Chr($3a);                   //kodiere minus auf 0x3A
        if ((inS[i]<='z') and (inS[i]>='a')) then inS[i] := Chr(Ord(inS[i]) - $20);	// falls Kleinbuchstaben -> Grobuchstaben
        if ((inS[i]<'0') or (inS[i]>'Z')) then inS[i] := Chr($3C);	                // falls nicht erlaubter wert -> Space
        if ((inS[i]>='=') and (inS[i]<='?')) then inS[i] := Chr($3C);                 // falls zwischcen < und ? (nicht erlaubt) -> space
        if ((inS[i]>='@') and (inS[i]<='Z')) then inS[i] := Chr(Ord(inS[i]) - 3);		// Luecke zwischen 0x3d und 0x3f schliessen
end;

i := 0;
while (i < strlen(inS)) do begin

        iii := (Ord(inS[i]) - $30) + (( Ord(inS[i+1]) -$30) * 40) + (( Ord(inS[i+2])-$30)* 1600) ;
        // printf("wert %d\n",(inS[i]-0x30) + ((inS[i+1]-0x30) * 40) + ((inS[i+2]-0x30)* 1600));

        // memcpy wird durch arithmetr. Funktionen ersetzt
        // memcpy(&outS[ii], &iii, 2);
        // Beachte: little-endian!!!
        outS[ii] := Chr(((iii shr 8) and $00FF));
        outS[ii+1] := Chr(iii and $00FF);

        ii := ii + 2;
        i := i + 3;
end;

c3_to_2 := ii;
end;

procedure c2_to_3(inS: PChar;  len: Word; outS: PChar);
var
i,ii,y: Word;
begin

ii := 0;
i := 0;
while i < len do begin
// memcpy wird durch arithmetr. Funktionen ersetzt
// memcpy(&y, &inS[i], 2);
// Beachte: little-endian!!!
y := (( Ord(inS[i]) shl 8) and $FF00) or (Ord(inS[i+1]) and $00FF);

        outS[ii] := Chr(y mod 40);
        y := y - Ord(outS[ii]);
        outS[ii+1] := Char((y mod 1600) div 40);
        y := y - (Ord(outS[ii+1])*40);
        outS[ii+2] := Chr(y div 1600);
        ii := ii + 3;
        i := i + 2;

end;

outS[ii] := Chr($00);
i := ii;

ii := 0;
while (ii < i) do begin

        outS[ii] := Chr(Ord(outS[ii]) + $30);
        if (Ord(outS[ii])=$3C) then outS[ii] := Chr($20);
        if (Ord(outS[ii])=$3b) then outS[ii] := Chr($2f);
        if (Ord(outS[ii])=$3A) then outS[ii] := Chr($2D);

        if ((outS[ii]>=Chr(Ord('@')-3)) and (outS[ii]<=Chr (Ord('Z')-3)) ) then outS[ii] := Chr(Ord(outS[ii]) + 3);
        if ((outS[ii]>='A') and (outS[ii]<='Z')) then outS[ii] := Chr(Ord(outS[ii]) + $20);

        ii := ii + 1;
end;

end;


end.
